

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.binary_evol.simulationproperties &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.binary_evol.simulationproperties</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.binary_evol.simulationproperties</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;Simulation properties for the population class.</span>

<span class="sd">This class contains the simulation properties, e.g. flow, steps and max_time. To</span>
<span class="sd">evolve a binary.</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span>
    <span class="s1">&#39;Tassos Fragos &lt;Anastasios.Fragkos@unige.ch&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Jeff Andrews &lt;jeffrey.andrews@northwestern.edu&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Nam Tran &lt;tranhn03@gmail.com&gt;&#39;</span><span class="p">,</span> <span class="s1">&#39;Simone Bavera &lt;Simone.Bavera@unige.ch&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Konstantinos Kovlakas &lt;kkovlakas@physics.uoc.gr&gt;&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Kyle Rocha &lt;kylerocha2024@u.northwestern.edu&gt;&#39;</span>
<span class="p">]</span>

<span class="kn">import</span> <span class="nn">time</span>

<div class="viewcode-block" id="SimulationProperties"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties">[docs]</a><span class="k">class</span> <span class="nc">SimulationProperties</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Properties of the binary evolution.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    properties : None or instance of SimulationProperties</span>
<span class="sd">        If None, then default values for the simulation properties are used.</span>
<span class="sd">        If SimulationProperties object is passed, then copies its properties.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># def __new__(cls, properties=None, **kwargs):</span>
    <span class="c1">#     &quot;&quot;&quot;Create a new instance of Simulation Properties class.</span>
    <span class="c1">#</span>
    <span class="c1">#     Parameters</span>
    <span class="c1">#     ----------</span>
    <span class="c1">#     cls : type</span>
    <span class="c1">#         Description of parameter `cls`.</span>
    <span class="c1">#     properties : object</span>
    <span class="c1">#         Simulation Properties class containing, e.g. flow, steps, max_time.</span>
    <span class="c1">#     **kwargs : dict</span>
    <span class="c1">#         Extra agument can be provided as kwargs.</span>
    <span class="c1">#</span>
    <span class="c1">#     Returns</span>
    <span class="c1">#     -------</span>
    <span class="c1">#     object</span>
    <span class="c1">#         Return the Simulation Properties class.</span>
    <span class="c1">#</span>
    <span class="c1">#     &quot;&quot;&quot;</span>
    <span class="c1">#     if properties is not None:</span>
    <span class="c1">#         # Error checking</span>
    <span class="c1">#         if not isinstance(properties, SimulationProperties):</span>
    <span class="c1">#             raise TypeError(&#39;properties argument in simulation_properties &#39;</span>
    <span class="c1">#                             &#39;initialization must be a previously defined &#39;</span>
    <span class="c1">#                             &#39;instance of SimulationProperties class.&#39;)</span>
    <span class="c1">#         return properties</span>
    <span class="c1">#     else:</span>
    <span class="c1">#         return super().__new__(cls)</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">properties</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Constructor of simulation properties object.</span>

<span class="sd">        # TODO: most of the stuff here is obsolete, clean the function.</span>
<span class="sd">        # NOTE: at the moment everyone passes the properties as an argument</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        properties : object</span>
<span class="sd">            Simulation Properties class containing, e.g. flow, steps, max_time.</span>
<span class="sd">        extra_hooks : list</span>
<span class="sd">            List of hooks classes or tuples containing the extra step name</span>
<span class="sd">            {&#39;extra_pre_evolve&#39;, &#39;extra_pre_step&#39;, &#39;extra_post_step&#39;,</span>
<span class="sd">            &#39;extra_post_evolve&#39;} and the corresponding function.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">kwargs</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">copy</span><span class="p">()</span>
        <span class="c1"># Check if binary_properties is passed</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">default_hooks</span> <span class="o">=</span> <span class="n">EvolveHooks</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">default_hooks</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;extra_hooks&#39;</span><span class="p">,</span> <span class="p">[]):</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="n">EvolveHooks</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span><span class="o">.</span><span class="n">append</span><span class="p">(</span> <span class="n">item</span> <span class="p">)</span>
            <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">item</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
                <span class="c1"># setting extra_pre/post_step/evolve methods</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">item</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">item</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;extra_hooks must be list of eithier classes deriving from EvolveHooks&quot;</span>
                                 <span class="s2">&quot;or tuples with the name of the extra function and the function.&quot;</span><span class="p">)</span>

        <span class="c1"># Binary parameters and parameterizations</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">initial_rotation</span> <span class="o">=</span> <span class="mf">0.0</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">mass_transfer_efficiency</span> <span class="o">=</span> <span class="mf">1.0</span>

        <span class="c1"># TODO: are these needed here, or should be defined where the step-takers</span>
        <span class="c1"># are defined?</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">common_envelope_efficiency</span> <span class="o">=</span> <span class="mf">1.0</span>

        <span class="c1"># Limits on simulation</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;max_time&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">max_time</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;end_events&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">end_events</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;end_states&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">end_states</span> <span class="o">=</span> <span class="p">[]</span>


        <span class="c1"># Set functions for evolution</span>

        <span class="c1">#        self.step_ZAMS = DefaultStepZAMS()</span>
        <span class="c1">#        self.step_CE = DefaultStepCE()</span>
        <span class="c1">#        self.step_SN = DefaultStepSN()</span>
        <span class="c1">#        self.step_RLO = DefaultStepRLO()</span>
        <span class="c1">#        self.flow = default_flow</span>
        <span class="k">for</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="s2">&quot;step&quot;</span> <span class="ow">in</span> <span class="n">key</span><span class="p">:</span>
                <span class="k">continue</span> <span class="c1"># skip loading steps</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">key</span><span class="p">,</span> <span class="n">val</span><span class="p">)</span>


<div class="viewcode-block" id="SimulationProperties.load_steps"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties.load_steps">[docs]</a>    <span class="k">def</span> <span class="nf">load_steps</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Instantiate step classes and set as instance attributes.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        verbose: bool</span>
<span class="sd">            Print extra information.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        None</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;STEP NAME&#39;</span><span class="o">.</span><span class="n">ljust</span><span class="p">(</span><span class="mi">20</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;STEP FUNCTION&#39;</span><span class="o">.</span><span class="n">ljust</span><span class="p">(</span><span class="mi">25</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;KWARGS&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">name</span><span class="p">,</span> <span class="n">tup</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">kwargs</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">tup</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
                <span class="k">if</span> <span class="n">verbose</span><span class="p">:</span> <span class="nb">print</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">tup</span><span class="p">,</span> <span class="n">end</span><span class="o">=</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">)</span>
                <span class="n">step_func</span><span class="p">,</span> <span class="n">kwargs</span> <span class="o">=</span> <span class="n">tup</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">step_func</span><span class="p">(</span><span class="o">**</span><span class="n">kwargs</span><span class="p">))</span></div>

<div class="viewcode-block" id="SimulationProperties.pre_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties.pre_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">pre_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Functions called before a binary evolves.</span>
<span class="sd">        Uses all extra hooks classes or extra functions.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">            The binary before evolution starts.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">hooks</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span><span class="p">:</span>
            <span class="n">hooks</span><span class="o">.</span><span class="n">pre_evolve</span><span class="p">(</span><span class="n">binary</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;extra_pre_evolve&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">extra_pre_evolve</span><span class="p">(</span><span class="n">binary</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="SimulationProperties.pre_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties.pre_step">[docs]</a>    <span class="k">def</span> <span class="nf">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called before every evolution step.</span>
<span class="sd">        Uses all extra hooks classes or extra functions.</span>
<span class="sd">        (except for undefined next step errors)</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">            The binary before evolution starts.</span>
<span class="sd">        step_name : str</span>
<span class="sd">            The name of the step about to be called (as defined in the flow).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">hooks</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span><span class="p">:</span>
            <span class="n">hooks</span><span class="o">.</span><span class="n">pre_step</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;extra_pre_step&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">extra_pre_step</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="SimulationProperties.post_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties.post_step">[docs]</a>    <span class="k">def</span> <span class="nf">post_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called after every evolution step.</span>
<span class="sd">        Uses all extra hooks classes or extra functions.</span>
<span class="sd">        (except for undefined next step errors)</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">            The binary before evolution starts.</span>
<span class="sd">        step_name : str</span>
<span class="sd">            The name of the step about to be called (as defined in the flow).</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="k">for</span> <span class="n">hooks</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span><span class="p">:</span>
            <span class="n">hooks</span><span class="o">.</span><span class="n">post_step</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;extra_post_step&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">extra_post_step</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="SimulationProperties.post_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties.post_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called after a binary exits the evolution loop.</span>
<span class="sd">        Uses all extra hooks classes or extra functions.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">            The binary after evolution is ended.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        binary : instance of &lt;class, BinaryStar&gt;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">hooks</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">all_hooks_classes</span><span class="p">:</span>
            <span class="n">hooks</span><span class="o">.</span><span class="n">post_evolve</span><span class="p">(</span><span class="n">binary</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s1">&#39;extra_post_evolve&#39;</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">extra_post_evolve</span><span class="p">(</span><span class="n">binary</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div></div>


<div class="viewcode-block" id="EvolveHooks"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.EvolveHooks">[docs]</a><span class="k">class</span> <span class="nc">EvolveHooks</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Base class for hooking into binary evolution.&quot;&quot;&quot;</span>
<div class="viewcode-block" id="EvolveHooks.pre_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.EvolveHooks.pre_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">pre_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called before a binary evolves.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="EvolveHooks.pre_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.EvolveHooks.pre_step">[docs]</a>    <span class="k">def</span> <span class="nf">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called before every evolution step.</span>
<span class="sd">        (except for undefined next step errors)&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="EvolveHooks.post_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.EvolveHooks.post_step">[docs]</a>    <span class="k">def</span> <span class="nf">post_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called after every evolution step.</span>
<span class="sd">        (except for undefined next step errors)&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="EvolveHooks.post_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.EvolveHooks.post_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function called after a binary exits the evolution loop.&quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">binary</span></div></div>


<div class="viewcode-block" id="TimingHooks"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.TimingHooks">[docs]</a><span class="k">class</span> <span class="nc">TimingHooks</span><span class="p">(</span><span class="n">EvolveHooks</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Adding history column &#39;step_times&#39; to each binary.</span>
<span class="sd">    Time taken to perform an evolutionary step.</span>

<span class="sd">    &gt;&gt;&gt; pop.to_df(extra_columns=[&#39;step_times&#39;])</span>
<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="TimingHooks.pre_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.TimingHooks.pre_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">pre_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="c1"># initial value to match history</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">step_times</span> <span class="o">=</span> <span class="p">[</span><span class="mf">0.0</span><span class="p">]</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="TimingHooks.pre_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.TimingHooks.pre_step">[docs]</a>    <span class="k">def</span> <span class="nf">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">step_start_time</span> <span class="o">=</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="TimingHooks.post_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.TimingHooks.post_step">[docs]</a>    <span class="k">def</span> <span class="nf">post_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="o">.</span><span class="n">append</span><span class="p">(</span> <span class="n">time</span><span class="o">.</span><span class="n">time</span><span class="p">()</span><span class="o">-</span><span class="bp">self</span><span class="o">.</span><span class="n">step_start_time</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span> <span class="o">&gt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="p">):</span>
            <span class="n">diff</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="p">)</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="o">+=</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span><span class="o">*</span><span class="p">(</span><span class="n">diff</span><span class="p">)</span>
        <span class="k">elif</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span> <span class="o">&lt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="p">):</span>
            <span class="n">last_items</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="o">=</span><span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="p">[</span><span class="o">-</span><span class="p">(</span><span class="n">last_items</span><span class="o">-</span><span class="mi">1</span><span class="p">):]</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="TimingHooks.post_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.TimingHooks.post_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">binary</span><span class="o">.</span><span class="n">event</span> <span class="o">==</span> <span class="s1">&#39;END&#39;</span> <span class="ow">or</span> <span class="n">binary</span><span class="o">.</span><span class="n">event</span> <span class="o">==</span> <span class="s1">&#39;FAILED&#39;</span><span class="p">:</span>
            <span class="n">diff</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="p">))</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_times</span><span class="o">+=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span><span class="o">*</span><span class="n">diff</span>
        <span class="k">return</span> <span class="n">binary</span></div></div>

<div class="viewcode-block" id="StepNamesHooks"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.StepNamesHooks">[docs]</a><span class="k">class</span> <span class="nc">StepNamesHooks</span><span class="p">(</span><span class="n">EvolveHooks</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Adding history column &#39;step_name&#39; to each binary.</span>
<span class="sd">    Name of evolutionary step as defined in SimulationProperties.</span>

<span class="sd">    &gt;&gt;&gt; pop.to_df(extra_columns=[&#39;step_names&#39;])</span>
<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="StepNamesHooks.pre_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.StepNamesHooks.pre_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">pre_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="c1"># initial value to match history</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">step_names</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;initial_cond&#39;</span><span class="p">]</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="StepNamesHooks.pre_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.StepNamesHooks.pre_step">[docs]</a>    <span class="k">def</span> <span class="nf">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="StepNamesHooks.post_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.StepNamesHooks.post_step">[docs]</a>    <span class="k">def</span> <span class="nf">post_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="o">.</span><span class="n">append</span><span class="p">(</span> <span class="n">step_name</span> <span class="p">)</span>
        <span class="n">len_binary_hist</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span>
        <span class="n">len_step_names</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="p">)</span>
        <span class="n">diff</span> <span class="o">=</span> <span class="n">len_binary_hist</span> <span class="o">-</span> <span class="n">len_step_names</span>
        <span class="k">if</span> <span class="n">len_binary_hist</span> <span class="o">&gt;</span> <span class="n">len_step_names</span><span class="p">:</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="o">+=</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span><span class="o">*</span><span class="p">(</span><span class="n">diff</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">len_binary_hist</span> <span class="o">&lt;</span> <span class="n">len_step_names</span><span class="p">:</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="o">=</span><span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="p">[</span><span class="o">-</span><span class="p">(</span><span class="n">len_binary_hist</span><span class="o">-</span><span class="mi">1</span><span class="p">):]</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="StepNamesHooks.post_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.StepNamesHooks.post_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">binary</span><span class="o">.</span><span class="n">event</span> <span class="o">==</span> <span class="s1">&#39;END&#39;</span> <span class="ow">or</span> <span class="n">binary</span><span class="o">.</span><span class="n">event</span> <span class="o">==</span> <span class="s1">&#39;FAILED&#39;</span><span class="p">:</span>
            <span class="n">diff</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">event_history</span><span class="p">)</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">step_names</span><span class="p">))</span>
            <span class="n">binary</span><span class="o">.</span><span class="n">step_names</span> <span class="o">+=</span> <span class="p">[</span><span class="kc">None</span><span class="p">]</span><span class="o">*</span><span class="n">diff</span>
        <span class="k">return</span> <span class="n">binary</span></div></div>



<div class="viewcode-block" id="PrintStepInfoHooks"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.PrintStepInfoHooks">[docs]</a><span class="k">class</span> <span class="nc">PrintStepInfoHooks</span><span class="p">(</span><span class="n">EvolveHooks</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Simple example for adding extra print info&quot;&quot;&quot;</span>
<div class="viewcode-block" id="PrintStepInfoHooks.pre_step"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.PrintStepInfoHooks.pre_step">[docs]</a>    <span class="k">def</span> <span class="nf">pre_step</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">,</span> <span class="n">step_name</span><span class="p">):</span>
        <span class="nb">print</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">index</span><span class="p">,</span> <span class="n">step_name</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div>

<div class="viewcode-block" id="PrintStepInfoHooks.post_evolve"><a class="viewcode-back" href="../../../api/posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.PrintStepInfoHooks.post_evolve">[docs]</a>    <span class="k">def</span> <span class="nf">post_evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">binary</span><span class="p">):</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;End evol for binary </span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">binary</span><span class="o">.</span><span class="n">index</span><span class="p">),</span> <span class="n">end</span><span class="o">=</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="o">*</span><span class="mi">2</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">binary</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>